package org.fouram.service;

import java.util.List;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.SplitUtil;
import org.fouram.dto.input.SapReportAuthDTO.SapReportAuthSaveDTO;
import org.fouram.dto.input.SapReportAuthDTO.SapReportAuthSelectListDTO;
import org.fouram.entity.SapReportAuth;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class SapReportAuthService extends BaseService {

	public void save(SapReportAuthSaveDTO dto) throws Exception {
		List<String> sapOrgIdList = SplitUtil.split(dto.getSapOrgIds(), ",");
		for (String sapOrgId : sapOrgIdList) {
			SapReportAuth entity = SapReportAuth.builder().wxUserId(dto.getWxUserId()).sapOrgId(sapOrgId).build();
			save("SapReportAuthMapper.save", entity);
		}
	}

	@SuppressWarnings("unchecked")
	public List<SapReportAuth> selectList(SapReportAuthSelectListDTO dto) throws Exception {
		return (List<SapReportAuth>) findList("SapReportAuthMapper.selectList", dto);
	}

	public void deleteById(Long id) throws Exception {
		update("SapReportAuthMapper.deleteById", id);
	}

	@SuppressWarnings("unchecked")
	public List<SapReportAuth> selectListByWxUserId(String wxUserId) throws Exception {
		return (List<SapReportAuth>) findList("SapReportAuthMapper.selectListByWxUserId", wxUserId);
	}
}
